<?php
/*
Plugin Name: SRG Clean Archives
Plugin URI: http://www.sporadicnonsense.com
Description: A nice uniform way to display your archives.
Version: 2.1
Author: Shawn Grimes
Author URI: http://www.sporadicnonsense.com
*/

function srg_clean_archives()
{
    global $month, $wpdb, $wp_version;
    $now = current_time('mysql');

    if ( version_compare($wp_version, '2.1', '<') )
        $current_posts = "post_date < '$now'";
    else
        $current_posts = "post_type='post'";

    $arcresults = $wpdb->get_results("SELECT DISTINCT YEAR(post_date) AS year, MONTH(post_date) AS month, count(ID) as posts  FROM " . $wpdb->posts . " WHERE post_status='publish' AND $current_posts AND post_password='' GROUP BY YEAR(post_date), MONTH(post_date) ORDER BY post_date DESC");
    
    if ($arcresults) {
        foreach ($arcresults as $arcresult) {
            $url = get_month_link($arcresult->year, $arcresult->month);
            $text = sprintf('%s %d', $month[zeroise($arcresult->month,2)], $arcresult->year);
            echo get_archives_link($url, $text, '','<strong>','</strong>');
            
            $thismonth = zeroise($arcresult->month,2);
            $thisyear = $arcresult->year;
            
            $arcresults2 = $wpdb->get_results("SELECT ID, post_date, post_title, comment_status FROM " . $wpdb-> posts . " WHERE post_date LIKE '$thisyear-$thismonth-%' AND $current_posts AND post_status='publish' AND post_password='' ORDER BY post_date DESC");
            
            if ($arcresults2) {
                echo "<ul class=\"postspermonth\">\n";
                foreach ($arcresults2 as $arcresult2) {
                       if ($arcresult2->post_date != '0000-00-00 00:00:00') {
                         $url       = get_permalink($arcresult2->ID);
                         $arc_title = $arcresult2->post_title;

                         if ($arc_title) $text = strip_tags($arc_title);
                        else $text = $arcresult2->ID;
                        $title_text = wp_specialchars($text, 1);

                          echo '<li>' . mysql2date('d', $arcresult2->post_date). ': ' . "<a href='$url' title='$title_text'>".wptexturize($text)."</a>";
                        // Here is where you can enable comment count if you would like, just remove the /* from the front and back of the line below
                        //Save the file and re-upload and you should have all your comment count again
                        /*$comments_count = $wpdb->get_var("SELECT COUNT(comment_id) FROM " . $wpdb->comments . " WHERE comment_post_ID=" . $arcresult2->ID . " AND comment_approved='1'");
                        if ($arcresult2->comment_status == "open" OR $comments_count > 0) echo ' (' . $comments_count . ')';*/
                        echo '</li>';
                     }
                }
                echo '</ul>';
            }
        }
    }
}
?>